
use locale;


sub dbDoSQL {
	my $command=$_[0];
	my $len=length($command);

	if ($len<5856) {
		if (!$dbh->do($command)) {
			print "Query length: $len\n";
			Error("While executing \"$command\"\n");
		}
	} else 
	{
		Warning("Do statement too big, not executing it...");
	}
}

#sub dbAddTrans {};

sub dbAddTrans {
	my ($orig,$trans,$flag)=@_;
	my $q,$count=0,$d;
	my $usecount=1;
	my $command;
	my $cond_o=$dbh->quote(&condCond($orig));
	my $cond_t=$dbh->quote(&condCond($trans));
	my $full_o=$dbh->quote(&condFull($orig));
	my $full_t=$dbh->quote(&condFull($trans));
	my $smart_o=$dbh->quote(&condSmart($orig));
	my $smart_t=$dbh->quote(&condSmart($trans));

	if ($flag ne "auth") {	
#		print "$orig\n";
		$q=$dbh->prepare("SELECT usecount FROM trans WHERE full_o=$full_o AND full_t=$full_t");
		$q->execute();
		$count=$q->fetchrow();
		$q->finish();
		$flag="''";
	} else {
		# count the number of times authority translation is used
		$q=$dbh->prepare("SELECT sum(usecount) FROM trans WHERE cond_o=$cond_o AND cond_t=$cond_t");
		$q->execute();
		$usecount=$q->fetchrow();
		$q->finish();

		&dbDoSQL("DELETE FROM trans WHERE cond_o=$cond_o AND cond_t=$cond_t");
		&dbDoSQL("UPDATE trans SET flagone='off' WHERE cond_o=$cond_o AND flagone!='auth'");
		$flag="'auth'";

		# insert it into auths table
		if (!$usecount) {$usecount=1;}
		&dbDoSQL("INSERT INTO auths VALUES ($cond_o,$cond_t,$usecount)");
		
		#Warning("while executing $command") unless $dbh->do($command);
	}

	$G_numtrans++;
	if ($G_numtrans % 400 == 0 ) {
		&dbVacuum();
	}


	if ($count==0) {
		&dbDoSQL("INSERT INTO trans VALUES ($cond_o,$cond_t,$full_o,$full_t,$smart_o,$smart_t,$usecount,0,$flag)");
	} else {
		$count++;
		&dbDoSQL("UPDATE trans SET usecount=$count WHERE full_o=$full_o AND full_t=$full_t");
	}
}

sub dbCheckAuth {
	my ($orig,$trans)=@_;

	my @suggs,@uses,$q,$sug;
	my $usecount,$ok=0;
	my $i,$auths=0;
	my $ret;

	my $cond_o=$dbh->quote(&condCond($orig));
	
	my $cond_t=&condCond($trans);

	$q=$dbh->prepare("SELECT cond_t,usecount FROM auths WHERE cond_o=$cond_o ORDER BY usecount DESC");
	$q->execute();
	while (($sug,$usecount)=$q->fetchrow()) {
		$uses[$auths]=$usecount;
		$suggs[$auths++]=$sug;
		if ($sug eq $cond_t) { $ok=1; break;}
	}
	$q->finish();
	if ($auths && !$ok) {
		$ret="$G_filename:$G_linenum - Auth err: $orig  -> $trans \nSuggetions: ";
		$i=0;
		while ($i<$auths) { 
			$sug=$suggs[$i];
			$usecount=$uses[$i];
			$ret.= "$sug($usecount), ";
			$i++;
		}

		$ret.="\n";
	}
	return ($ret);

}



sub dbPrintStat {
	my $q;
	my $count,$off,$off2,$distinct_o=0,$distinct_t=0,$auth;
	
	

	$q=$dbh->prepare("SELECT count(*) FROM trans");
	$q->execute();
	$count=$q->fetchrow();
	$q->finish();

	$q=$dbh->prepare("SELECT sum(usecount) FROM trans WHERE flagone='off'");
	$q->execute();
	$off=$q->fetchrow();
	$q->finish();

	$q=$dbh->prepare("SELECT distinct on (cond_o,cond_t) cond_o,1 FROM trans");
	$q->execute();
	while ($q->fetchrow()) {$off2++};
	$q->finish();
	
	$q=$dbh->prepare("SELECT distinct on (cond_o) cond_o,1 FROM trans");
	$q->execute();
	while ($q->fetchrow()) {$distinct_o++};
	$q->finish();
		

	$q=$dbh->prepare("SELECT distinct on (cond_t) cond_t,1 FROM trans");
	$q->execute();
	while ($q->fetchrow()) {$distinct_t++};
	$q->finish();


	$q=$dbh->prepare("SELECT count(*) FROM trans where flagone='auth'");
	$q->execute();
	$auth=$q->fetchrow();
	$q->finish();

	print "Distinct pairs: $count
Distinct pairs (condensed): $off2
Distinct originals (condensed): $distinct_o
Distinct translations (condensed): $distinct_t
Authority translations: $auth
Translations conflicting authorities: $off

";
	
}


sub dbConnect
{
        $dbh = DBI->connect("DBI:Pg:dbname=$dbname", "$dbusername", "");
        Error ("Cannot connect to postgres database")  unless $dbh;
        $dbh->do("SET DateStyle TO 'European'");
	if ($G_transact) {
		$dbh->{AutoCommit}=0;
	}
}

sub dbDisconnect {
        if (($dbh ne "death")&&($dbh))
        {
		if ($G_transact) { 
			$dbh->commit(); 
		}
                $dbh->disconnect;
                $dbh="death";
        }
}

sub dbVacuum {
	# Use it's own connection when transactions are active
        my $v;
	if (($G_transact)||(!$dbh)||($dbh eq "death")) {
 		$v = DBI->connect("DBI:Pg:dbname=$dbname", "$dbusername", "");
	} else {
		$v=$dbh;
	}
	print "Vacuuming (& analyzing) the database...\n";
	$v->do("VACUUM ANALYZE trans");
	$v->do("VACUUM ANALYZE auths");
	
	if (($G_transact)||(!$dbh)||($dbh eq "death")) {
		$v->disconnect();
	}
}

sub dbInit {

if ($dbh->do("drop table trans")) {
	print "Tables were already created... droping them\n";
	$dbh->do("drop table auths");
}

Error("Creating table trans") unless $dbh->do ("create table trans (
	cond_o text,
	cond_t text,

	full_o text,
	full_t text,

	smart_o text,
	smart_t text,


	usecount int,
	priority int,
	flagone varchar(255)

)");	
#	UNIQUE (full_o,full_t)

Error("Creating table auths") unless $dbh->do ("create table auths (
	cond_o text,
	cond_t text,
	usecount int,
	PRIMARY KEY (cond_o,cond_t)
)");	

print "Creating indexes...\n";
Error("Creating indexes 0") unless $dbh->do ("CREATE UNIQUE INDEX full_idx ON trans USING btree (full_o,full_t)");	
#Error("Creating indexes 1") unless $dbh->do ("CREATE INDEX full_o_idx ON trans USING hash (full_o)");	
#Error("Creating indexes 2") unless $dbh->do ("CREATE INDEX full_t_idx ON trans USING hash (full_t)");	


&dbDisconnect();

&dbVacuum();
	

print"\nTables and functions created successefully\n";



}





1;
