
use DBI;


$dbusername=$dbname="minmax";

$G_datatype="GNOME";
$G_workmode="COLLECT";
$G_authmode=0;
$G_verbose=5;
$G_inconsistency=0;
$G_filename="";
$G_linenum="Unknown line";
$G_key="";
$G_transact=0;
$G_numtrans=0;

$G_pre_full="#f_";
$G_pre_smart="#s_";
$G_pre_cond="#c_";


sub Error {
	print STDERR "\nError: $_[0]\n";
	print "\nError: $_[0]\n";
	die;
}
sub Warning {
	print "\nWarning: $_[0]\n";
}

sub smartExit {
	&dbDisconnect();
	exit();
}

sub smart_init {
	&dbConnect();

	setlocale(LC_CTYPE, "sl_SI.ISO8859-2"); # potrebno zaradi \w	


	foreach $arg (@ARGV) {
		if ($arg eq "-k") {$G_datatype="KDE"; print "Data type set to KDE\n"} 
		if ($arg eq "-g") {$G_datatype="GNOME"; print "Data type set to GNOME\n";}
		if ($arg eq "-i") {$G_inconsistency=1; $G_verbose=4; print "WorkMode set to inconsistency check\n";}
		if ($arg=~m/\-\-infile\=(.*)/) {$G_filename=$1; print "\n\nWorking on: $1\n";}
		if ($arg eq "-t") {$G_workmode="TRANS"; }
		if ($arg eq "-b") {
				print "Brutal submode\n";
				$G_pre_full="";
				$G_pre_smart="";
				$G_pre_cond="";
		}
		if ($arg eq "-c") {$G_workmode="COLLECT";}
		if ($arg eq "--version") {
			print "Smart $G_version\n\n";
			smartExit();
		}
		if ($arg eq "--initdb") {
			&dbInit(); 
			smartExit();
		}
		if ($arg eq "--stat") {
			&dbPrintStat();
			smartExit();
		}
		if ($arg eq "--vacuum") {
			&dbVacuum(); 
			smartExit();
		}
		if ($arg eq "--help") {
		
		print "
	Computer Aided Regular Translation (CART) usage:
	
	-t		- translating work mode
		-b	- Brutal mode, no #f_, #c_ and #s_

	-c		- collecting work mode (default)
	-i		- inconsistency work mode

	-k	- KDE data type ('&' for keybindings)
	-g	- GNOME data type ('_' for keybindings) (default)

	--infile=FILE	- filename for input (stdin is default)
	--dbinit	- creates needed tables and functions in SQL database
	--stat		- vacuums the database & prints statistics
	--vacuum	- vacuums the database
	--version	- prints version & exits
	--help		- prints this help screen\n\n

For input and output use standard stdin and stdout streams,
files should be in .po format (by gettext)

(c) Andraz Tori (andraz.tori1\@guest.arnes.si)
func. 'tasuhi' (c) Ale Koir (ales.kosir\@hermes.si)\n\n";
			smartExit();
		}
	} 
	
	$w=$dbh->prepare("SELECT count(*) FROM trans");
	$w->execute();
	$G_numtrans=$w->fetchrow();
	$w->finish();


	if ($G_datatype eq "GNOME") {
		$G_key='_';
	} else {
		$G_key='\&';
	}

}





1;