
use locale;

sub lowercase {
	my $tmp=$_[0];
	$tmp=lc($tmp);
	$tmp=~tr/ȩ/蹾/;
	return ($tmp);	
}
sub uppercase {
	my $tmp=$_[0];
	$tmp=uc($tmp);
	$tmp=~tr/蹾/ȩ/;
	return ($tmp);	
}

# translates from smart key notation(^) to GNOME(_) or KDE (&)
sub trKeyToUser {  
	my $tmp=$_[0];
	$tmp=~s/\^/$G_key/gi;	#converts ^ to & or _
 	return ($tmp);

}
# translates from smart key notation(^) to GNOME(_) or KDE (&)
sub trUserToKey {  
	my $tmp=$_[0];
	$tmp=~s/$G_key/\^/gi;	#converts & or _ to ^
 	return ($tmp);
}

#clears all types of keys from string (normal & hotkeys)
sub clearKeys {
	my $tmp=$_[0];

	$tmp=~s/\^//gi;	#converts ^ to & or _
	$tmp=clearHotkeys($tmp);
	return ($tmp);
}

sub clearHotkeys {
	my $toc=$_[0];
#	if ($G_datatype eq "KDE") {	#clears out KDE style hotkeys
		$toc=~s/ ?\(\&[a-zA-Z]\)//gi;
#	}
	return ($toc);
}

sub getHotkeys {
	my $toc=$_[0];
#	if ($G_datatype eq "KDE") {	#gets KDE style hotkeys
		$toc=~m/ ?\(\&[a-zA-Z]\)/;
		return ($1);
#	}
#	return (0);
}



sub onlyWords {
# cleans out everything but _-A-Za-z...
# also clear hotkeys
# used in doCase

#convert from \\n ->\n
	my $tmp=$_[0];
	$tmp=eval("\"$tmp\"");

#then clean up the thing
	$tmp=~s/$G_key//gi;
	$tmp=~s/[^_-a-zA-Z蹾ȩ]/ /gi;
	return($tmp);
}

sub testnasih {
	$a="";
	if ($a=~m/\w/) {
		print "umniki so ustrezno podprti v perl-u \n";
	}

}

sub trToEsc {
	# translate escaped escape codes to escape codes
	my $orig=$_[0];
	$orig=~s/\\n/\n/gi;
	$orig=~s/\\t/\t/gi;
	return ($orig);
}

sub trFromEsc {
	# transte escaped codes to escaped escape codes
	my $orig=$_[0];
	$orig=~s/\n/\\n/gi;
	$orig=~s/\t/\\t/gi;
	return ($orig);
}

sub trEscEscToSpace {
	#translate escaped escape codes to spaces
	my $tmp=$_[0];
	$tmp=~s/\\n/ /gi;	#changes \n chars to spaces
	$tmp=~s/\\t/ /gi;	#changes \t chars to spaces
	return ($tmp);
}

sub clearSpaces {
	# cuts out multi spaces & leading & following spaces
	my $toc=$_[0];
	$toc=~s/^ *(.*?) *$/$1/gi;     #cuts out leading and following spaces
	$toc=~s/( )\1*/$1/gi;         #cuts out multi-spaces
	return ($toc);
}


sub getContext {
	my $orig=$_[0];
	my $check=$_[1];

	# newline and tab are part of the context
	# make sure they are threated that way

	# get the context
	$orig=&trToEsc($orig);

	# chars that should be used for context matching... touchy subject
#		$cchars='[ \.\:\!\;\n\t\[\]\<\>]';
#

	# decide between two context possibilities
	if (!$check) { 
		$cchars='[^\w\(\)\&\%]';
	} else {	
		$cchars='[\.\:\!\;\n\t\[\]]';
		$orig=~s/ //gi; #whitespaces are non-context while checking
	}

	
	$orig=~m/(^$cchars*).*?($cchars*$)/;
	my ($prefix,$postfix)=($1,$2);
	
	# recover from manipulations above
	$prefix=&trFromEsc($prefix);
	$postfix=&trFromEsc($postfix);

	return ($prefix,$postfix);


}

sub addContext {
# makes context according to original 
# that means it copies beggining and the end of the text from orginal to
# translation...

	my $orig=$_[0];
	my $trans=$_[1];

	# gets hot keys from original
	my $hotkeys=&getHotkeys($orig);

	# clears hotkeys out
	$orig=&clearHotkeys($orig);
	$trans=&clearHotkeys($trans);

	#get the context	
	my ($prefix,$postfix)=&getContext($orig);
	if ($hotkeys) {
		$postfix .="$hotkeys";
	}

	# add the context
	my $ret=$prefix . $trans . $postfix;
	return($ret);
}


sub checkContext {
# checks if context of original and translation are the same
	my $orig=$_[0];
	my $trans=$_[1];

	$orig=&clearHotkeys($orig);
	$trans=&clearHotkeys($trans);

	my ($prefix_o,$postfix_o)=&getContext($orig,1);
	my ($prefix_t,$postfix_t)=&getContext($trans,1);

	if ($prefix_o ne $prefix_t) {
		return ("$G_filename:$G_linenum - Prefix diff: $orig ($prefix_o)- $trans ($prefix_t)\n");
	}
	if ($postfix_o ne $postfix_t) {
		return ("$G_filename:$G_linenum - Postfix diff: $orig ($postfix_o) - $trans ($postfix_t)\n");
	}
	return (0);
}


sub conv_case_full {
	my ($trans)=@_;
	my $trans2=$trans;
	$trans2=~s/\^//gi;
	if ($capped_words{uppercase($trans2)}) {
		return(uppercase($trans));
	}
	return($trans);

}

sub addCase {
# find one of three types of case setting and format translation accordingly	

# Can work out the following cases:
# - first character of the first word is capitalized
# - first characters of all words are capitalized (more than 1/2 of words though)
# - fully capitalized words
# - all words are fully capitalized

# warning .. keysbindings are presented as ^

#	%capped_words IS GLOBAL

	my $orig=$_[0];
	my $trans=$_[1];
	
	$orig=clearSpaces($orig);
	$orig=&onlyWords($orig); 
	my @words=split (/ /, $orig);
	
	# "first capitalized"
	my $firstC=($orig=~m/^[A-Z]/);
	if ($firstC) { 
#		print "Firstc\n";	
		$trans=~s/^(\^?.)/\U$1\E/;
	}

	# "all capitalized"

	my $countC,$word;
	foreach $word (@words) {            #counts the capitalized words
		
		if ($word=~m/^[A-Z]/ ) {
			$countC++;		
		}
	}

	my $numwords=scalar(@words);
	if ($numwords>1) {                  #sanity check
		if ($numwords<$countC*2) {    #if more than half of words are capitalized
			$trans=~s/([^\^\w])(\^?\w)/$1\U$2\E/gi;
		}
	}

	# "fully capitalized words" -> captitalize them in translation too
	# example: GNOME
	
	my $capwords=0; # counter of fully capitalized words
	
	# get all the capitalized words to capped_words...
	foreach $word (@words) {
		$capped_words{$word}="1";		
		if ($word eq uc($word)) {
			$capped_words{$1}=1;
			$capwords++;
		}
	}
	
	$trans=~s/\b([\w\^]+)\b/conv_case_full($1)/egi;
	
#			$trans=~s/\b($w)\b/$w/gi;

	# capped_words is global.. celan it up
	foreach $word (keys(%capped_words)) {
		$capped_words{$word}=0;
	}

	
	# "fully capitalized original"
	if ($capwords==$numwords) {
		$trans=&uppercase($trans);
	}

	return ($trans);
}





sub clearChars {
# cleans out all unimportant characters
	my $toc=$_[0];

	$toc=&clearHotkeys($toc);
	$toc=~s/\\\"/\"/gi;	#changes \" chars to "  

	# has to be done after removal of hotkeys ...
	$toc=trUserToKey($toc);

	$toc=&trEscEscToSpace($toc);
	$toc=~s/[\]\[\.\,\-\:\;\&\_\!\?\<\'\`\>\"\@]/ /gi;

	$toc=&clearSpaces($toc);
	return ($toc);
}

sub condSmart {
# clears out dirty characters, but leaves hotkeys and converts
# everything to lowercase
	my $toc=$_[0];
	$toc=&clearChars($toc);
	$toc=lowercase($toc);    #converts everything to lowercase
	return ($toc);
}

sub condFull {
# only converts & and _ to ^
	my $toc=$_[0];
	$toc=trUserToKey($toc);
	return ($toc);
}

sub condCond {
# does like smart but clears out ^ 
	my $toc=$_[0];
	$toc=&condSmart($toc);
	$toc=~s/\^//gi;		#cuts out . and -
	return ($toc);
}




1;