

use locale;


sub doTranslated {
	my $orig=$_[0];
	my $trans=$_[1];

	if ($orig && $trans) { 
		my $cond_t=$dbh->quote(&condCond($trans));
	
		if ($cond_t) {
			if ($G_inconsistency) {
				my $context=&checkContext($orig,$trans);	
				if ($context) {print "$context";}

				my $checkLex=&checkLex($trans);
				if ($checkLex) { print ($checkLex); }

				my $checkAuth=&dbCheckAuth($orig,$trans);
				if ($checkAuth) { print ($checkAuth); }

			} else {
				my $flag="";
				if ($G_authmode) { $flag="auth" };
				dbAddTrans($orig,$trans,$flag);
			}
		} else {
			if (($notfirst>1)&&($G_verbose == 5)) { #to skip the header
				print "Something is missing at line $G_linenum ($orig, $trans)\n";
		
			};
			$notfirst++;
		}
	}
}




sub doTranslation {
	
	my $orig=$_[0];
	my $trans;
	my %done_trans;
	$all++;
	if ($orig) {
		$G_num_untrans++;
		my $cond_t,$full_t,$trans,$priority,$flagone;
		my $smart_on,$found=0;	
		$cond_o=$dbh->quote(&condCond($orig));
		$full_o=$dbh->quote(&condFull($orig));
		$smart_o=$dbh->quote(&condSmart($orig));

		$smart_on=0;
		if ($smart_o=~m/\^/) {
			$smart_on=1;
		};

		$q=$dbh->prepare("SELECT cond_t,sum(usecount) FROM trans WHERE cond_o=$cond_o AND flagone!='off' GROUP BY cond_t ORDER BY sum(usecount) DESC");
		$q->execute();
		
		
		while (($cond_t)=$q->fetchrow()) {
			
			if ($cond_t) {$found=1;} else { next;};
			my $f_f=0;
			my $f_c=0;
			my $f_s=0;
			my $d;
			my $f_num,$s_num,$c_num;
			$cond_tt=$cond_t;
			$cond_t=$dbh->quote($cond_t);

			$d=$dbh->prepare("SELECT full_t FROM trans WHERE cond_t=$cond_t AND full_o=$full_o AND flagone!='off' ORDER BY usecount DESC");
			$d->execute();
			while ($full_t=$d->fetchrow()) {
				$trans=$full_t;
				if ($smart_on) {
					$trans=&trKeyToUser($trans);
				} else
				{
					$trans=&clearKeys($trans);
				}
				if (!$done_trans{$trans}) {
					$done_trans{$trans}=1;
					$f_f++;
					print $G_pre_full. "msgstr \"$trans\"\n";
				}
			}
			$d->finish();	
			if ($smart_on) {
				$d=$dbh->prepare("SELECT smart_t FROM trans WHERE cond_t=$cond_t AND smart_o=$smart_o AND full_o!=$full_o AND flagone!='off' GROUP BY smart_t ORDER BY sum(usecount) DESC");
				$d->execute();
				while ($smart_t=$d->fetchrow()) {
					$trans=$smart_t;
					$trans=&addCase($orig,$trans);
					$trans=&addContext($orig,$trans);
					$trans=&trKeyToUser($trans);

					if (!$done_trans{$trans}) {
						$done_trans{$trans}=1;
						$f_s++;
						print $G_pre_smart. "msgstr \"$trans\"\n";
					}
				}
				$d->finish();	
			}
			if ($f_s + $f_f==0) {
				$trans=$cond_tt;
				$trans=&addCase($orig,$trans);
				$trans=&addContext($orig,$trans);
				if (!$done_trans{$trans}) {
					$done_trans{$trans}=1;
					$f_c++;
					print $G_pre_cond. "msgstr \"$trans\"\n";	
				}
			}
			
			$found_f+=$f_f;
			$found_c+=$f_c;
			$found_s+=$f_s;
		}
		$q->finish();
			
	
		if ($found) {
			$f_distinct++;
		} else {
			print "msgstr \"\"\n";
		}
	}


}



sub doTranslation_old {
	
	my $orig=$_[0];
	my $trans;
	if ($orig) {
		$f_trans++;
		my $found_f=0;
		my $found_c=0;
		my $found_s=0;
	
		my $cond,$trans,$priority,$flagone;
		$cond_o=$dbh->quote(&condCond($orig));
		$full_o=$dbh->quote(&condFull($orig));
		$smart_o=$dbh->quote(&condSmart($orig));
	
		my ($f_f,$f_s,$f_c);

		my %condDone;
		$q=$dbh->prepare("SELECT cond_t,full_t,priority,flagone FROM trans WHERE full_o=$full_o AND flagone!='off' GROUP BY cond_t, full_t,priority,flagone");
		$q->execute();
		
		while (($cond,$trans,$priority,$flagone)=$q->fetchrow()) {
			$f_f++;
	
			$trans=&trKeyToUser($trans);
			print "#f_". "msgstr \"$trans\"\n";
			$condDone {$cond}="1";
			
	
		}
		$q->finish();
			
	
	
		$q=$dbh->prepare("SELECT cond_t, smart_t,priority,flagone FROM trans WHERE smart_o=$smart_o AND full_o!=$full_o AND flagone!='off' GROUP BY cond_t, smart_t,priority,flagone");
		$q->execute();
		while (($cond,$trans,$priority,$flagone)=$q->fetchrow()) {
			if (!$condDone{$cond}) { #if we already did full match that is similar by translation
				$f_s++;
				$trans=&addCase($orig,$trans);
				$trans=&addContext($orig,$trans);
				$trans=&trKeyToUser($trans);
				print "#s_". "msgstr \"$trans\"\n";
				$condDone {$cond}="1";
		
			}
		}
		$q->finish();
			
	
		$q=$dbh->prepare("SELECT cond_t,priority,flagone FROM trans WHERE cond_o=$cond_o AND smart_o!=$smart_o AND flagone!='off' GROUP BY cond_t,priority,flagone");
		$q->execute();
		while (($trans,$priority,$flagone)=$q->fetchrow()) {
			if (!$condDone{$trans}) { #if we already did full or smart match that is similar by translation
				$f_c++;
				$trans=&addCase($orig,$trans);
				$trans=&addContext($orig,$trans);
				print "#c_". "msgstr \"$trans\"\n";	
			}
		}
		$q->finish();
			
	
		if ($f_f+$f_c+$f_s>0) {
			$f_distinct++;
		} else {
			print "msgstr \"\"\n";
		}
	}


}







1;
